/*!
 * © 2021 David Vines
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
 */

const djvtimedifftext = function(element,from) {
		const diff = Math.floor(Math.abs(new Date().getTime() - from.getTime())/1000); // In seconds
		const fromday = Intl.DateTimeFormat(undefined,{weekday:"long"}).format(from);
		const yesterday = Intl.DateTimeFormat(undefined,{weekday:"long"}).format(new Date(Date.now()-86400000));
		const timediff = ( diff < 60        ? "Just now"
						:( diff < 120       ? "A minute ago"
						:( diff < 3600      ? Math.floor(diff/60)+" minutes ago"
						:( diff < 7200      ? "An hour ago"
						:( diff < 86400     ? Math.floor(diff/3600)+" hours ago"
						:( (diff < 86400*2 && fromday === yesterday) ? "Yesterday"
						:( diff < 86400*6   ? "Last "+ Intl.DateTimeFormat(undefined,{weekday:"long"}).format(from)
						:( diff < 86400*14  ? "A week ago"
						:( diff < 86400*35  ? Math.floor(diff/86400/7)+" weeks ago"
						:( diff < 86400*61  ? "A month ago"
						:( diff < 86400*360 ? Math.floor(diff/86400/30)+" months ago"
						:( diff < 86400*730 ? "A year ago"
						:Math.floor(diff/86400/365.25)+" years ago"
						))))))))))));
		const nexttimediff = ( diff < 3660 ? 60
							 :( diff < 90000 ? 3600
							 :86400
							 ));
		while (element.firstChild != null) {
			element.removeChild(element.firstChild);
		}
		element.appendChild(document.createTextNode(timediff));
		window.setTimeout(() => {
			djvtimedifftext(element,from);
		}, nexttimediff*1000);
};

document.addEventListener('DOMContentLoaded', (_event) => {
	const elements = document.querySelectorAll("span[data-isotime]");
	for(let element of elements) {
		djvtimedifftext(element,new Date(element.dataset.isotime));
	}
});